#ifndef DIRDIALOG_H
#define DIRDIALOG_H
#include <qfileinfo.h>
#include <qdialog.h>

class FileView;
class QButton;
class QVBox;

class FileDialog : public QDialog
{ 
    Q_OBJECT

public:
    FileDialog(const QString& path ,const QString& mask , QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
    ~FileDialog();
    const QString selectedFile();


private slots:
	void selectChanged(const QFileInfo & fi);
	void okPressed();

private:
    FileView* fileSelect;
    QPushButton* okButton;
    QVBox* base;

	QString selectF;

};

#endif
