/****************************************************************************
** Form implementation generated from reading ui file 'test.ui'
**
** Created: Mon Nov 24 21:36:19 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "MenuItemDialog.h"

#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qpe/qpeapplication.h>
#include <qpe/mimetype.h>
#include <qpe/applnk.h>
#include <qmessagebox.h>

#include "FileDialog.h"
#include "MListItem.h"
#include "AplDialog.h"

/* 
 *  Constructs a MenuItemDialog which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
MenuItemDialog::MenuItemDialog( MListItem* m, char keyMapping[] ,bool res, QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	item = m;
	reserved = res;
	setCaption( tr( "MenuEdit" ) );
	MenuItemDialogLayout = new QGridLayout( this); 
	MenuItemDialogLayout->setSpacing( 2 );
	MenuItemDialogLayout->setMargin( 5 );
	MenuItemDialogLayout->setColStretch(0,2);
	MenuItemDialogLayout->setColStretch(1,0);
	MenuItemDialogLayout->setColStretch(2,2);
	MenuItemDialogLayout->setColStretch(3,0);

	itemTypeLabel = new QLabel( this, "itemTypeLabel" );
	itemTypeLabel->setText( tr( "Item Type" ) );
	MenuItemDialogLayout->addWidget( itemTypeLabel, ItemTypeRow, Label1Col );
	itemTypeBox = new QComboBox( FALSE, this, "itemTypeBox" );
	itemTypeBox->setMinimumWidth(10);
	itemTypeBox->insertItem(tr("QtApps") , MenuItem::QtApps);
	itemTypeBox->insertItem(tr("ShellW") , MenuItem::ShellW);
	itemTypeBox->insertItem(tr("ShellD") , MenuItem::ShellD);
	itemTypeBox->insertItem(tr("QCop") , MenuItem::QCopSend);
	itemTypeBox->insertItem(tr("Menu")   , MenuItem::Menu);
	MenuItemDialogLayout->addWidget( itemTypeBox, ItemTypeRow, Box1Col );
	
	if (reserved) {
		itemTypeBox->setEnabled(false);
	} else {
		itemTypeBox->setEnabled(true);
	}

	autoTitleBox = new QCheckBox( this, "autoTitleBox" );
	autoTitleBox->setText( tr( "Auto Titile" ) );
	MenuItemDialogLayout->addMultiCellWidget( autoTitleBox, ItemTypeRow, ItemTypeRow, Label2Col, Box2Col);

	titleLabel = new QLabel( this, "titleLabel" );
	titleLabel->setText( tr( "Title" ) );
	MenuItemDialogLayout->addWidget( titleLabel, TitleRow, Label1Col );
	titleEdit = new QLineEdit( this, "titleEdit" );
	MenuItemDialogLayout->addMultiCellWidget( titleEdit, TitleRow, TitleRow,  Box1Col ,Box2Col );

	execButton = new QPushButton( this, "execButton" );
	execButton->setText( tr( "Program" ) );
	MenuItemDialogLayout->addWidget( execButton, ExecRow, Label1Col );
	execEdit = new QLineEdit( this, "execEdit" );
	MenuItemDialogLayout->addMultiCellWidget( execEdit, ExecRow, ExecRow ,Box1Col ,Box2Col );

	addParamLabel = new QLabel( this, "addParamLabel" );
	addParamLabel->setText( tr( "Add Param" ) );
	MenuItemDialogLayout->addWidget( addParamLabel, AddParamRow, Label1Col );
	addParamEdit = new QLineEdit( this, "addParamEdit" );
	MenuItemDialogLayout->addMultiCellWidget( addParamEdit, AddParamRow, AddParamRow, Box1Col ,Box2Col);

	firstParamLabel = new QLabel( this, "firstParamLabel" );
	firstParamLabel->setText( tr( "1st Param" ) );
	MenuItemDialogLayout->addWidget( firstParamLabel, ParamBoxRow, Label1Col );
	firstParamBox = new QComboBox( FALSE, this, "firstParamBox" );
	firstParamBox->setMinimumWidth(10);
	firstParamBox->insertItem(tr("Always")  , MenuItem::Always);
	firstParamBox->insertItem(tr("DirOnly") , MenuItem::DirOnly);
	firstParamBox->insertItem(tr("FileOnly"), MenuItem::FileOnly);
	firstParamBox->insertItem(tr("InputS"), MenuItem::Inputs);
	firstParamBox->insertItem(tr("Separate") ,MenuItem::Separate);
	firstParamBox->insertItem(tr("InputD"), MenuItem::Inputd);
	MenuItemDialogLayout->addWidget( firstParamBox, ParamBoxRow, Box1Col );

	secondParamLabel = new QLabel( this, "secondParamLabel" );
	secondParamLabel->setText( tr( "2nd Param" ) );
	MenuItemDialogLayout->addWidget( secondParamLabel, ParamBoxRow, Label2Col );
	secondParamBox = new QComboBox( FALSE, this, "secondParamBox" );
	secondParamBox->setMinimumWidth(10);
	secondParamBox->insertItem(tr("Always") , MenuItem::Always);
	secondParamBox->insertItem(tr("DirOnly"), MenuItem::DirOnly);
	secondParamBox->insertItem(tr("FileOnly"),MenuItem::FileOnly);
	secondParamBox->insertItem(tr("InputS"),MenuItem::Inputs);
	secondParamBox->insertItem(tr("NotUse") , MenuItem::NotUseParam);
	secondParamBox->insertItem(tr("InputD"),MenuItem::Inputd);
	MenuItemDialogLayout->addWidget( secondParamBox, ParamBoxRow, Box2Col );

	msgStrLabel = new QLabel( this, "msgStrLabel");
	msgStrLabel->setText( tr("Msg"));
	MenuItemDialogLayout->addWidget( msgStrLabel, MsgStrRow, Label1Col );
	msgStrEdit = new QLineEdit(this, "msgStrEdit");
	MenuItemDialogLayout->addMultiCellWidget( msgStrEdit, MsgStrRow, MsgStrRow, Box1Col ,Box2Col);

	menuShortLabel = new QLabel( this);
	menuShortLabel->setText( tr( "Shortcut" ) );
	MenuItemDialogLayout->addWidget( menuShortLabel, ShortRow, Label1Col );
	menuShortBox = new QComboBox( FALSE, this);
	menuShortBox->setMinimumWidth(10);
	MenuItemDialogLayout->addWidget( menuShortBox, ShortRow, Box1Col );
	menuShortBox->insertItem(tr("NotUse"));
	for (char c = '0' ; c <= '9' ; ++c) {
		menuShortBox->insertItem(QString(QChar(c)));
	}
	for (char c = 'A' ; c <= 'Z' ; ++c) {
		menuShortBox->insertItem(QString(QChar(c)));
	}

	hKeyMap.clear();
	for (int i = 0; i < MenuItem::Short_Size ; ++i) {
		hKeyMap.append(hKeyTbl[i]);
	}
	hotShortLabel = new QLabel( this);
	hotShortLabel->setText( tr( "HotKey" ) );
	MenuItemDialogLayout->addWidget( hotShortLabel, ShortRow, Label2Col );
	hotShortBox = new QComboBox( FALSE, this);
	hotShortBox->setMinimumWidth(10);
	MenuItemDialogLayout->addWidget( hotShortBox, ShortRow, Box2Col );
	hotShortBox->insertItem(tr("NotUse"));

	for (int i = 1; i < MenuItem::Short_Size ; ++i) {
		if (keyMapping[i] == 0 ) {
			hotShortBox->insertItem(hKeyMap[i]);
		}
	}

	init();
	MenuItemDialogLayout->activate();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
MenuItemDialog::~MenuItemDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

void MenuItemDialog::init()
{
	itemTypeBox->setCurrentItem(item->type());
	autoTitleBox->setChecked(item->autoT());
	titleEdit->setReadOnly(item->autoT());
	titleEdit->setText(item->name());
	execEdit->setText(item->pathName());
	addParamEdit->setText(item->paramForm());
	firstParamBox->setCurrentItem(item->p1Type());
	secondParamBox->setCurrentItem(item->p2Type());
	msgStrEdit->setText(item->msgDisp());
	menuShortBox->setCurrentItem(item->shortKey());
	for (int i = 1 ; i < hotShortBox->count() ; ++i) {
		if (hotShortBox->text(i) == hKeyMap[item->hotKey()]) {
			hotShortBox->setCurrentItem(i);
			break;
		}
	}
//	hotShortBox->setCurrentItem(item->hotKey());
	typeChanged(item->type());
	connect (autoTitleBox, SIGNAL(toggled(bool)) , this, SLOT(autoClicked(bool)) );
	connect (itemTypeBox,  SIGNAL(activated(int)), this, SLOT(typeChanged(int))  );
	connect (execButton,   SIGNAL(clicked())     , this, SLOT(execPushed())      );
}

void MenuItemDialog::accept()
{
	int hkey = hKeyMap.findIndex(hotShortBox->currentText());
	if (hkey < 0) {
		hkey = 0;
	}
	item->setItems(
		itemTypeBox->currentItem(),
		autoTitleBox->isChecked(),
		titleEdit->text(),
		execEdit->text(),
		addParamEdit->text(),
		firstParamBox->currentItem(),
		secondParamBox->currentItem(),
		msgStrEdit->text(),
		menuShortBox->currentItem(),
		hkey
	);
	QDialog::accept();
}

/*
void MenuItemDialog::reject()
{
}
*/
void MenuItemDialog::autoClicked(bool b)
{
	if (reserved) {
		autoTitleBox->setChecked(FALSE);
		titleEdit->setReadOnly(true);
	} else if (itemTypeBox->currentItem() == MenuItem::QtApps) {
		titleEdit->setReadOnly(b);
	} else {
		autoTitleBox->setChecked(FALSE);
		titleEdit->setReadOnly(FALSE);
	}
}

void MenuItemDialog::typeChanged(int i)
{
	if (reserved) {
		titleEdit->setReadOnly(true);
	}
	if  ( i == MenuItem::Menu) {
		execButton->setEnabled(false);
		execEdit->setEnabled(false);
		addParamEdit->setEnabled(false);
		firstParamBox->setEnabled(false);
		secondParamBox->setEnabled(false);
		msgStrEdit->setEnabled(false);
		menuShortBox->setEnabled(true);
		if (reserved ) {
			hotShortBox->setEnabled(true);
		} else {
			hotShortBox->setEnabled(false);
		}
	} else {
		execButton->setEnabled(true);
		execEdit->setEnabled(true);
		addParamEdit->setEnabled(true);
		firstParamBox->setEnabled(true);
		secondParamBox->setEnabled(true);
		msgStrEdit->setEnabled(true);
		menuShortBox->setEnabled(true);
		hotShortBox->setEnabled(true);
	}
	if (i == MenuItem::QtApps ) {
		firstParamBox->setCurrentItem(MenuItem::FileOnly);
		secondParamBox->setCurrentItem(MenuItem::NotUseParam);
		autoTitleBox->setChecked(TRUE);
	} else if ( i == MenuItem::QCopSend ) {
		firstParamBox->setCurrentItem(MenuItem::FileOnly);
		secondParamBox->setCurrentItem(MenuItem::NotUseParam);
		autoTitleBox->setChecked(FALSE);
	} else {
		autoTitleBox->setChecked(FALSE);
	}
}

void MenuItemDialog::execPushed()
{
	switch (itemTypeBox->currentItem()) {
	case  MenuItem::QtApps:
		{
			AplDialog d(this);
			if (d.exec() == QDialog::Accepted) {
				execEdit->setText(d.desktopName());
				if (autoTitleBox->isChecked()) {
					const AppLnk* app = new AppLnk(execEdit->text());
					titleEdit->setText(app->name());
					delete app;
				}
			}
			break;
		}
	case MenuItem::Menu:
	case MenuItem::QCopSend:
		break;
	default:
		{
			QString path ;
			QString mask;
			path = "/opt/QtPalmtop/bin/*";
			mask = "*";
			FileDialog f(path , mask , this);
			f.showMaximized();
			if (f.exec() == QDialog::Accepted) {
				execEdit->setText(f.selectedFile());
			}
		}
	}
}

const char* MenuItemDialog::hKeyTbl[] = {
	"",
	"^0","^1","^2","^3","^4","^5","^6","^7","^8","^9",
	"^A","^B","^C","^D","^E","^F","^G","^H","^I","^J",
	"^K","^L","^M","^N","^O","^P","^Q","^R","^S","^T",
	"^U","^V","^W","^X","^Y","^Z","DEL",",","-"
};

