#include "MenuItem.h"

MenuItem::MenuItem() 
{
}

MenuItem::MenuItem(int lev,int t,bool a, const QString& n, const QString& p, const QString& pa, int p1,int p2, const QString& ms, int s, int h)
{
	setItems(lev,t,a,n,p,pa,p1,p2,ms,s,h);
}

MenuItem::~MenuItem()
{
}

void MenuItem::setItems(int lev,int t,bool a, const QString& n, const QString& p, const QString& pa, int p1,int p2,const QString& ms, int s, int h)
{
	level = lev;
	itemType = t;
	autoTitle = a;
	title = n;
	path = p;
	param = pa;
	firstParam = p1;
	secondParam = p2;
	msg = ms;
	sKey = s;
	hKey = h;
	
}

const char MenuItem::sCode[] = {
	0,
	'0','1','2','3','4','5','6','7','8','9',
	'A','B','C','D','E','F','G','H','I','J',
	'K','L','M','N','O','P','Q','R','S','T',
	'U','V','W','X','Y','Z',',','-'
};

const int MenuItem::hCode[] = {
	0,
	Qt::CTRL+Qt::Key_0,Qt::CTRL+Qt::Key_1,Qt::CTRL+Qt::Key_2,Qt::CTRL+Qt::Key_3,Qt::CTRL+Qt::Key_4,
	Qt::CTRL+Qt::Key_5,Qt::CTRL+Qt::Key_6,Qt::CTRL+Qt::Key_7,Qt::CTRL+Qt::Key_8,Qt::CTRL+Qt::Key_9,
	Qt::CTRL+Qt::Key_A,Qt::CTRL+Qt::Key_B,Qt::CTRL+Qt::Key_C,Qt::CTRL+Qt::Key_D,Qt::CTRL+Qt::Key_E,
	Qt::CTRL+Qt::Key_F,Qt::CTRL+Qt::Key_G,Qt::CTRL+Qt::Key_H,Qt::CTRL+Qt::Key_I,Qt::CTRL+Qt::Key_J,
	Qt::CTRL+Qt::Key_K,Qt::CTRL+Qt::Key_L,Qt::CTRL+Qt::Key_M,Qt::CTRL+Qt::Key_N,Qt::CTRL+Qt::Key_O,
	Qt::CTRL+Qt::Key_P,Qt::CTRL+Qt::Key_Q,Qt::CTRL+Qt::Key_R,Qt::CTRL+Qt::Key_S,Qt::CTRL+Qt::Key_T,
	Qt::CTRL+Qt::Key_U,Qt::CTRL+Qt::Key_V,Qt::CTRL+Qt::Key_W,Qt::CTRL+Qt::Key_X,Qt::CTRL+Qt::Key_Y,
	Qt::CTRL+Qt::Key_Z,Qt::Key_Delete,Qt::Key_Comma,Qt::Key_Minus
};

