#include <qcolor.h>

#include "View.h"

View::View(QWidget * parent, const char * name ) : QMultiLineEdit(parent,name)
{
	setFocusPolicy(QWidget::WheelFocus);
	setReadOnly(true);
	clearTableFlags(Tbl_autoHScrollBar);
	setWordWrap(QMultiLineEdit::WidgetWidth);
	setWrapPolicy(QMultiLineEdit::Anywhere);
}

View::~View()
{
}

void View::keyPressEvent ( QKeyEvent * e )
{
/*
	switch (e->key() ) {
	case Key_Tab:
		clearFocus();
		break;
	case Key_Up:
		cursorUp();
		end();
		home(true);
		break;
	case Key_Down:
		cursorDown();
		end();
		home(true);
		break;
	case Key_PageUp:
		pageUp();
		end();
		home(true);
		break;
	case Key_PageDown:
		pageDown();
		end();
		home(true);
		break;
	default:
		QMultiLineEdit::keyPressEvent(e);
	}
*/
	if (e->key() == Key_Tab) {
		clearFocus();
	} else {
		QMultiLineEdit::keyPressEvent(e);
	}

}

void View::paintCell ( QPainter * painter, int row, int a)
{
//	painter->setPen(QColor(255,0,0));
	QMultiLineEdit::paintCell(painter,row,a);
}
