#include "MListItem.h"

MListItem::MListItem(QListView* parent,QListViewItem* after) : QListViewItem(parent,after)
{
	init();
}

MListItem::MListItem(QListViewItem* parent,QListViewItem* after) : QListViewItem(parent,after)
{
	init();
}


MListItem::~MListItem()
{
}


void MListItem::init()
{
	itemType = MenuItem::QtApps;
	autoTitle = true;
	title = "";
	path = "";
	param = "$1 $2";
	firstParam = MenuItem::Always;
	secondParam = MenuItem::Always;
	msg = "";
	sKey = MenuItem::Short_No;
	hKey = MenuItem::Short_No;
	setText(0,"");
	setText(1,"");
}

void MListItem::setItems(int type , bool at ,const QString& t, const QString& p, const QString& r, int p1,int p2, const QString& ms, int sk, int hk)
{
	itemType = type;
	autoTitle = at;
	title = t;
	path = p;
	param = r;
	firstParam = p1;
	secondParam = p2;
	msg = ms;
	if (msg.length() == 0 ) {
		msg = " ";
	}
	sKey = sk;
	hKey = hk;
	setText(0,title);
	QString tp;
	switch ( itemType ) {
	case MenuItem::QtApps:
		tp = " [Apps ]";
		break;
	case MenuItem::Menu:
		tp = " [Menu ]";
		break;
	default:
		tp = " [Shell]";
		break;
	}
	setText(1,tp);
}

void MListItem::setParam(const QString& s)
{
	param = s;
}
