#ifndef MLISTITEM_H
#define MLISTITEM_H


#include <qlistview.h>
#include <qstring.h>

#include "../FileLaunch/MenuItem.h"

class MListItem :  public QListViewItem
{ 
//    Q_OBJECT

public:
	MListItem(QListView* parent,QListViewItem* after) ;
	MListItem(QListViewItem* parent,QListViewItem* after) ;
	~MListItem();
	int type() { return itemType ;};
	bool autoT() { return autoTitle; };
	QString& name() { return title; };
	QString& pathName() { return path; };
	QString& paramForm() { return param; };
	int p1Type() { return firstParam ; };
	int p2Type() { return secondParam; };
	QString& msgDisp() { return msg; };
	int shortKey() { return sKey; };
	int hotKey() { return hKey; };

	void setItems(int type , bool at, const QString& t, const QString& p, const QString& r, int p1,int p2,const QString& ms, int sk, int hk);
	void setParam(const QString& s);

private:
	void init();


	int itemType;
	bool autoTitle;
	QString title;
	QString path;
	QString param;
	int firstParam;
	int secondParam;
	QString msg;
	int sKey;
	int hKey;
};

#endif
