#include <stdio.h>
#include <sys/vfs.h>

void progexit() {
	printf("modname 0.0.1\n");
	printf("Usage: pathname\n");
	exit(0);
}

int main( int argc, char **argv )
{
	if ( argc != 2 ) {
		progexit();
	} else {
		struct statfs stat;
		if (statfs(argv[1], &stat) == 0 ) {
			if (stat.f_type == 0x4d44) { // MSDOS_SUPER_MAGIC ) {
				printf("FAT\n");
			} else {
				printf("NOT FAT\n");
			}
		}
	}
}
